Uses CRT;

{-----------------------------------------}
{  This example allows programmer to use  }
{     all computer memory (up to 4GB).    }
{                                         }
{ Works in pure DOS.   Needs Real Mode of }
{ processor.   Don't try to execute under }
{ Windows. You'll get nothing. Better     }
{ load previous DOS version or boot using }
{ DOS system diskette.                    }
{                                         }
{    Program doesn't work under memory    }
{   managers such as Himem.sys, Emm.exe,  }
{             Qemm.exe etc.               }
{                                         }
{ Written by Alexei. A. Frounze  (c) 1999 }
{ E-mail:     alexfru@chat.ru             }
{ Homepage:   http://www.chat.ru/~alexfru }
{-----------------------------------------}

{$L 4GB.OBJ}

Procedure Enable_A20;                                   External;
Procedure Disable_A20;                                  External;
Function  Check_Safety : Byte;                          External;
Procedure PMode;                                        External;
Function  MemRB (Offs : LongInt) : Byte;                External;
Function  MemRW (Offs : LongInt) : Word;                External;
Function  MemRL (Offs : LongInt) : LongInt;             External;
Procedure MemWB (Offs : LongInt; Value : Byte);         External;
Procedure MemWW (Offs : LongInt; Value : Word);         External;
Procedure MemWL (Offs : LongInt; Value : LongInt);      External;
Function XMS_Avail : Word; { in KB }                    External;

Const
  Msg : Array [0..2] of String[63] = (
    'Processor is in Real Mode, Himem.sys isn''t loaded.',
    'Processor is in Protected Mode.',
    'Processor is in Real Mode, Himem.sys is loaded.'
  );

Var
  S : Byte;
  XMS,
  Offs, Size, I, X : LongInt;
  Err : Boolean;

Begin
  ClrScr;
  If Test8086 < 2 then Begin
    WriteLn ('At least 80386 processor is neded.');
    Exit
  End;
  S := Check_Safety;
  WriteLn (Msg[S]);
  If S <> 0 then Begin
    WriteLn ('Exiting...');
    Exit
  End;

  { Enable line A20 for accessing to all installed memory }
  Enable_A20;
  { Create 4GB segment in Protected Mode and return back to Real Mode }
  PMode;
  { Determaine amount of XMS memory by reading CMOS }
  XMS := XMS_Avail;
  WriteLn ('XMS installed above 1M: ', XMS, ' KB');

  { Skip 1st 64KB block above 1MB. There can lie part of DOS. }
  XMS := XMS-64;
  If XMS < 64 then Begin
    WriteLn ('Too small memory. 64 KB is neded. Exiting...');
    { Disable line A20 }
    Disable_A20;
    Exit
  End;

  Write ('Press the Enter key to pass a memory test...'); ReadLn;
  ClrScr;
  WriteLn ('Program is testing 2nd 64KB above 1MB using LongInts...');
  WriteLn ('  Offset Written    Read');
  Window (1, 3, 80, 19);

  Offs := 1024*1024 + 65536;    { 1MB+64KB = beginning of memory we can use }
  Size := XMS*1024;             { Size of XMS in bytes }

  Err := False;
  I := 0;
  Repeat
    MemWL (Offs+I, I);                  { Writing }
    X := MemRL (Offs+I);                { Reading }
    Write (Offs+I:8, I:8, X:8);         { Displaying }
    If I <> X then Begin                { Checking }
      Write (' ERROR');
      Err := True;
      Break
    End;
    WriteLn;
    Inc (I, 4)
  Until I >= 16384*4;                   { 16384 LongInts }

  Window (1, 1, 80, 25);
  GotoXY (1, 19);

  If not Err then WriteLn ('Test was passed successfully.')
  Else WriteLn ('Error occured during passing the test.');

  { Disable line A20 }
  Disable_A20;
End.
